package cytoPrefuse;

import java.awt.geom.Rectangle2D;

import prefuse.action.Action;
import prefuse.action.ZoomToFitAction;
import prefuse.data.Graph;
import prefuse.data.tuple.TupleSet;

public class SearchGridLayoutPostProcessAction extends Action {

	private Graph graph;
	private Rectangle2D zoomBounds = new Rectangle2D.Float();
	private String animateAction;
	private SearchGridLayout searchGridLayout;
     
	public SearchGridLayoutPostProcessAction(SearchGridLayout searchGridLayout, Graph graph, String animateAction){
		this.graph = graph;
		this.searchGridLayout = searchGridLayout;
		this.animateAction = animateAction;
	}
	public void run(double frac) {

        CytoPrefuse cytoPrefuse = (CytoPrefuse) m_vis.getDisplay(0);                 
       TupleSet nodes = graph.getNodes();        
        cytoPrefuse.setCytoscapePostionsFromLayout (nodes);
    
        EdgeBundler edgeBundler = cytoPrefuse.edgeBundler;
        if (edgeBundler != null){
       		edgeBundler.recomputeLocations();
       		m_vis.run("color");
    	}
        m_vis.run("aggLayout");          
        zoomBounds.setRect( searchGridLayout.findFilterBounds());
        Action zoomToFit = new ZoomToFitAction(	m_vis.getDisplay(0), zoomBounds, 1000);           
        m_vis.putAction("zoomToFit", zoomToFit);
       	if (animateAction != null){
            m_vis.run(animateAction);
            m_vis.runAfter(animateAction, "zoomToFit");
       	}else{
       		m_vis.run("zoomToFit");
        }
       	
       	m_vis.run("repaint");
     	
	}

}
